# XMPP::MUC::Room Class Reference

`#include <xmpp_muc.h>`

Inheritance diagram for XMPP::MUC::Room:

List of all members.

## Public Member Functions

| Room (C2S::StreamHandler *handler, const JID &jid, const PString &nick)
| Our user in the room.
const User & | GetUser () const
const Users & | GetOtherUsers () const
virtual PBoolean | Enter ()
virtual PBoolean | Leave ()
virtual PBoolean | SendMessage (const PString &msg)
virtual PBoolean | SendMessage (Message &msg)
virtual void | OnMessage (Message &msg)
virtual void | OnRoomJoined ()
virtual void | OnRoomLeft ()
virtual void | OnUserAdded (User &user)
virtual void | OnUserRemoved (User &user)
virtual void | OnUserChanged (User &user)

## Protected Member Functions

| PDECLARE_SMART_NOTIFIER (C2S::StreamHandler, Room, OnSessionReleased)
| PDECLARE_SMART_NOTIFIER (Message, Room, OnMessage)
| PDECLARE_SMART_NOTIFIER (Presence, Room, OnPresence)

## Protected Attributes

C2S::StreamHandler * | m_Handler
BareJID | m_RoomJID
User | m_User
Users | m_OtherUsers
PNotifierList | m_MessageHandlers
PNotifierList | m_RoomJoinedHandlers
PNotifierList | m_RoomLeftHandlers
PNotifierList | m_UserAddedHandlers
PNotifierList | m_UserRemovedHandlers
PNotifierList | m_UserChangedHandlers

## Constructor & Destructor Documentation

XMPP::MUC::Room::Room | ( | C2S::StreamHandler * | handler,
|  | const JID & | jid,
|  | const PString & | nick |
| ) |  |  |

Our user in the room.

Parameters:

  handler | The C2S stream handler
  jid | The room's jid

## Member Function Documentation

virtual PBoolean XMPP::MUC::Room::Enter | ( |  | ) | `[virtual]`

const Users& XMPP::MUC::Room::GetOtherUsers | ( |  | ) | const`[inline]`

const User& XMPP::MUC::Room::GetUser | ( |  | ) | const`[inline]`

virtual PBoolean XMPP::MUC::Room::Leave | ( |  | ) | `[virtual]`

virtual void XMPP::MUC::Room::OnMessage | ( | Message & | msg | ) | `[virtual]`

virtual void XMPP::MUC::Room::OnRoomJoined | ( |  | ) | `[virtual]`

virtual void XMPP::MUC::Room::OnRoomLeft | ( |  | ) | `[virtual]`

virtual void XMPP::MUC::Room::OnUserAdded | ( | User & | user | ) | `[virtual]`

virtual void XMPP::MUC::Room::OnUserChanged | ( | User & | user | ) | `[virtual]`

virtual void XMPP::MUC::Room::OnUserRemoved | ( | User & | user | ) | `[virtual]`

XMPP::MUC::Room::PDECLARE_SMART_NOTIFIER | ( | Presence | ,
|  | Room | ,
|  | OnPresence |  |
| ) |  |  | `[protected]`

XMPP::MUC::Room::PDECLARE_SMART_NOTIFIER | ( | Message | ,
|  | Room | ,
|  | OnMessage |  |
| ) |  |  | `[protected]`

XMPP::MUC::Room::PDECLARE_SMART_NOTIFIER | ( | C2S::StreamHandler | ,
|  | Room | ,
|  | OnSessionReleased |  |
| ) |  |  | `[protected]`

virtual PBoolean XMPP::MUC::Room::SendMessage | ( | Message & | msg | ) | `[virtual]`

virtual PBoolean XMPP::MUC::Room::SendMessage | ( | const PString & | msg | ) | `[virtual]`

## Member Data Documentation

C2S::StreamHandler* XMPP::MUC::Room::m_Handler `[protected]`

PNotifierList XMPP::MUC::Room::m_MessageHandlers `[protected]`

Users XMPP::MUC::Room::m_OtherUsers `[protected]`

BareJID XMPP::MUC::Room::m_RoomJID `[protected]`

PNotifierList XMPP::MUC::Room::m_RoomJoinedHandlers `[protected]`

PNotifierList XMPP::MUC::Room::m_RoomLeftHandlers `[protected]`

User XMPP::MUC::Room::m_User `[protected]`

PNotifierList XMPP::MUC::Room::m_UserAddedHandlers `[protected]`

PNotifierList XMPP::MUC::Room::m_UserChangedHandlers `[protected]`

PNotifierList XMPP::MUC::Room::m_UserRemovedHandlers `[protected]`

The documentation for this class was generated from the following file:

- xmpp_muc.h